<template>
    <div>
            <TableHeader  ref="TableHeaderRef">
                <template #select>
                <el-form-item label="工程名称">
                    <el-input v-model="tableStore.table.params.projectName" clearable></el-input>
                </el-form-item>
                <el-form-item label="所属地市">
                    <el-select v-model="tableStore.table.params.city" clearable placeholder="请选择所属地市">
                        <el-option
                            v-for="item in areaOptionList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.name"
                        ></el-option>
                    </el-select>
                </el-form-item>
            </template>
                <template #operation>
                    <!-- <el-button icon="el-icon-Download" type="primary">导出</el-button> -->
                </template>
            </TableHeader>
            <Table ref="tableRef" />


        <el-dialog title='详情' width='80%' v-model='dialogShow'><DetailInfo :id='userId'></DetailInfo></el-dialog>
        </div>

</template>
<script setup lang="ts">
import { ref, onMounted, provide, nextTick } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { ElMessage, ElMessageBox } from 'element-plus'
import { mainHeight } from '@/utils/layout'
import { useDictData } from '@/stores/dictData'
import DetailInfo from '../../interfere/components/undocumented/detail.vue'

const dictData = useDictData()

const TableHeaderRef = ref()
const areaOptionList = dictData.getBasicData('jibei_area')
const tableStore = new TableStore({
    url: '/supervision-boot/userReport/getInterferenceUserPage',
    publicHeight: 65,
    method: 'POST',
    column: [
        { title: '序号', type: 'seq', width: 80 },
        { field: 'projectName', title: '工程名称', minWidth: 170 },
        {
            field: 'userType',
            title: '用户性质',
            minWidth: 150,
            formatter: (obj: any) => {
                const userType = obj.row.userType
                return getUserTypeName(userType)
            }
        },
        { field: 'city', title: '所属地市', minWidth: 80 },
        { field: 'responsibleDepartment', title: '归口管理部门', minWidth: 130 },
        {
            field: 'userStatus',
            title: '用户状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'primary',
                1: 'primary',
                2: 'success',
                3: 'warning'
            },
            replaceValue: {
                0: '可研',
                1: '建设',
                2: '运行',
                3: '退运'
            }
        },
        { field: 'substation', title: '变电站', minWidth: 100 },


        {
            title: '操作',
            minWidth: 150,
            fixed: 'right',
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '详细信息',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    click: row => {
                        lookInfo(row.id)
                    }
                }
            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
    }
})
tableStore.table.params.city='' 
tableStore.table.params.projectName='' 
tableStore.table.params.loadType = ''
tableStore.table.params.userName = ''
tableStore.table.params.relationUserName = ''
tableStore.table.params.aisFileUpload = ''

const userId = ref()
const dialogShow = ref(false)

const lookInfo = (id:string) =>{
    userId.value = id
    dialogShow.value = true

}

provide('tableStore', tableStore)
onMounted(() => {
    tableStore.index()
})


/**获取用户性质*/
const getUserTypeName = (userType: any) => {
    if (userType === 0) {
        return '新建电网工程'
    }
    if (userType === 1) {
        return '扩建电网工程'
    }
    if (userType === 2) {
        return '新建非线性负荷用户'
    }
    if (userType === 3) {
        return '扩建非线性负荷用户'
    }
    if (userType === 4) {
        return '新建新能源发电站'
    }
    if (userType === 5) {
        return '扩建新能源发电站'
    }
    if (userType === 6) {
        return '敏感及重要用户'
    }
    return '新建电网工程'
}
</script>
